#!/usr/bin/env python

import os, sys, base64

VERSIONEER_b64 = """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"""
newver = "0.22"


def main():
    if len(sys.argv) < 2:
        print("Usage: versioneer install")
        sys.exit(1)

    command = sys.argv[1]
    if command in ("version", "--version"):
        print("versioneer (installer) %s" % newver)
        sys.exit(0)

    if command != "install":
        print("Usage: versioneer install")
        sys.exit(1)

    v = base64.b64decode(VERSIONEER_b64.encode('ASCII'))
    if os.path.exists("versioneer.py"):
        for line in open("versioneer.py").readlines()[:5]:
            if line.startswith("# Version: "):
                oldver = line[len("# Version: "):].strip()
                if oldver != newver:
                    print("replacing old versioneer.py (%s)" % oldver)
                break
        else:
            print("overwriting existing versioneer.py")
    with open("versioneer.py", "wb") as f:
        f.write(v)
    print("versioneer.py (%s) installed into local tree" % newver)
    print("Now running 'versioneer.py setup' to install the generated files..")
    if " " in sys.executable:
        import subprocess  # Do not import unless absolutely necessary to avoid compatibility issues
        subprocess.call([sys.executable, "versioneer.py", "setup"])
    else:
        os.execl(sys.executable, sys.executable, "versioneer.py", "setup")

if __name__ == '__main__':
    main()
